{$A+,B-,E-,F-,N-,O-,V-,I- }

{$IFDEF DEBUG }
  {$D+,L+,R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit loading;

interface

type
     page_map      = record
                       Data : byte;
                       Att  : word;
                     end;
     Std_page      = array[0..959] of page_map;
     PStd_page     = ^Std_page;

(* --- attention: l'ordre a de l'importance : --- *)
type Panel_map = record
                   Graphik    : byte;
                   Panel      : word;
                   PanelActif : word;
                 end;

const
     RIEN        = 250;
     CarGraphik  = 240;
     Complement  = 176;
     Tabulation  = 8;
     BasePanel   = 519;
     Vierge    : page_map = (data : 0; Att : 0);

const
      E_OK      = 1;
      E_REPRISE = 2;
      E_ABANDON = 4;
      E_IGNORE  = 8;
      E_OUI     = 16;
      E_NON     = 32;

      MPRO1 = #27#$39;
      MPRO2 = #27#$3A;
      MPRO3 = #27#$3B;
      MOFF  = #$60;
      MON   = #$61;
      MSTART = #$69;
      MSTOP  = #$6A;
      MROULEAU = #$43;
      MEEcran = #$50; (* module emeteur code *)
      MEClavier = #$51;
      MEModem = #$52;
      MEPrise = #$53;
      MREcran = #$58; (* module recepteur code *)
      MRClavier = #$59;
      MRModem = #$5A;
      MRPrise = #$5B;

(******************* VIDEO ********************)

const
     MskGraphik     = 8192;
     Xgraphik       = 11;
     Ygraphik       = 10;


type
   Param_map = record
    IntroCur   : byte;
    VideLnZero : boolean;
    VideEcran  : boolean;
    TypeM1B    : boolean;
    TypeRTIC   : boolean;
    ModeAff    : byte; (* ex AffHautBas *)
    SauteVide  : boolean;
    ComplAsSpace : boolean; (* ex ComplementSpace *)
    OptimiseRep : boolean;
    PlaceCur   : boolean;
    PLigne     : byte;
    PColonne   : byte;
    PPanel     : word;
    ConcluCur  : byte;
    LongChain  : byte; (* nbre de fichier chaine *)
    LgCode1    : byte; { longueur debut }
    LgCode2    : byte; { longueur fin }
                 end;

type MemPg_Rec = record
         Show     : Std_page;
         Param    : Param_map;
         Chain    : String;
         Code1    : String;
         Code2    : String;
         FileName : string[12];
         ImgChg   : boolean;
       end;
     PMemPg_Rec = ^MemPg_Rec;

     ZonePg_Rec = array[0..959] of byte;
     PZonePg_Rec = ^ZonePg_Rec;

procedure InitMemPg( var M : MemPg_Rec );
function  LoadSingleMem( var M : MemPg_Rec; name:string) : boolean;

implementation

const InitParam : Param_map = (
        IntroCur   : 0;
        VideLnZero : false;
        VideEcran  : true;
        TypeM1B    : false;
        TypeRTIC   : false;
        ModeAff    : 0;
        SauteVide  : true;
        ComplAsSpace : false;
        OptimiseRep : true;
        PlaceCur   : false;
        PLigne     : 0;
        PColonne   : 0;
        PPanel     : BasePanel;
        ConcluCur  : 0;
        LongChain  : 0;
        LgCode1    : 0;
        LgCode2    : 0
         );


procedure InitParametrage( var M : MemPg_Rec );
begin
  M.param := InitParam;
  M.Chain := '';
  M.Code1 := '';
  M.Code2 := '';
end;

procedure InitMemPg( var M : MemPg_Rec );
begin
  InitParametrage(M);
  M.FileName := '';
  M.ImgChg := FALSE;
  FillChar(M.Show,sizeof(M.Show),0);
end;

const DriveAbandon : boolean = FALSE;
      DriveError   : word    = 0;

var  fichier : file of byte;

const
     FileVer = 0; (* version de travail *)

     SFIX    = 0;
     SADD    = 1; (* commande SeekPos *)
     SSUB    = 2;

     BPRIVE      = 0; (* code identifiant block *)
     BIMAGE      = 1;
     BPANEL      = 2;
     BPARAMETRES = 3;
     BCHAINAGE   = 4;
     BCODE1      = 5;
     BCODE2      = 6;


procedure SeekPos(num : LongInt; cwd : byte);
begin
  case cwd of
    SFIX : Seek(fichier,num);
    SADD : Seek(fichier,FilePos(fichier)+num);
    SSUB : begin
             num := FilePos(fichier)-num;
             if num<0 then num := 0;
             Seek(fichier,num);
           end;
  end;
end;

function GetByte : byte;
var colector : byte;
    io : word;
begin
  if not(DriveAbandon) then
    begin
      read(fichier,colector);
      io := ioresult;
      if io<>0 then
        begin
          DriveAbandon := true;
          DriveError := io;
          GetByte := 0;
        end
      else
        GetByte := colector;
    end
  else GetByte := 0;
end;

function GetWord : word;
var tempo : byte;
begin
  tempo := GetByte;
  GetWord := tempo or (GetByte shl 8);
end;

function GestFileError( io : word ) : boolean;
begin
  if io<>0 then
    begin
      writeln('disk error : ',io);
      GestFileError := FALSE;
    end
  else GestFileError := TRUE;
end;

function CloseFile : boolean;
var io : word;
begin
  close(fichier);
  io := ioresult;
  if DriveAbandon then
    CloseFile := GestFileError(DriveError)
  else
    CloseFile := GestFileError(io);
end;

function LoadEnTete : boolean;
const EnTete1 : string[4] = 'dti'#26;     (* nouveau! *)
      EnTete2 : string[4] = #16#06#66#09; (* ancien!! *)
var buf : string[4];
    index : byte;
begin
  for index := 1 to 4 do buf[index] := char(GetByte);
  buf[0] := char(4);
  LoadEnTete := (buf=Entete1) or (buf=Entete2);
end;

procedure LoadBIMAGE( var M : MemPg_Rec );
procedure LoadFullSingleImage;
var index : word;
begin
  for index := 0 to 959 do
    with M.Show[index] do
      begin
        data := GetByte;
        Att  := GetWord;
      end;
end;
procedure LoadCompil0SingleImage( long : word);
var index : word; (* index dans l'image *)
    Rlong : word; (* longueur lu *)
    m_data : byte;
    tempo : byte;
    Jindex : word;
begin
  index := 0;
  Rlong := 0;
  while (index<960) and (Rlong<long) do
    begin
      m_data := GetByte;
      if m_data=1 then
        begin
          tempo := GetByte;
          for Jindex := 1 to tempo do
            begin
              M.Show[index] := vierge;
              Inc(index);
            end;
          Inc(Rlong,2);
        end
      else
        begin
          with M.Show[index] do
            begin
              data := m_data;
              att  := GetWord;
            end;
          Inc(index);
          Inc(Rlong,3);
        end;
    end;
  if Rlong<long then SeekPos(long-Rlong,SADD); (* en cas d'erreur ! *)
  if index<960 then
    for Jindex := index to 959 do M.Show[index] := vierge; (* erreur ! *)
end;
procedure LoadCompact( long : word );
var index : word; (* index dans l'image *)
    Rlong : word; (* longueur lu *)
    w     : page_map;
    tempo : byte;
    Jindex : word;
    L     : page_map;
begin
  index := 0;
  Rlong := 0;
  L.data := 0;
  L.att  := 0;
  while (index<960) and (Rlong<long) do
    begin
      w.data := GetByte;
      if w.data=1 then
        begin
          w.data := 0;
          w.att  := 0;
          tempo := GetByte;
          for Jindex := 1 to tempo do
            begin
              M.Show[index] := vierge;
              Inc(index);
            end;
          Inc(Rlong,2);
        end
      else
        if w.data=2 then
          begin
            w.data := L.data; { et oui! }
            tempo := GetByte;
            for Jindex := 1 to tempo do
              begin
                M.Show[index] := L;
                inc(index);
              end;
            Inc(Rlong,2);
          end
        else
          begin
            w.att := GetWord;
            M.Show[index] := w;
            Inc(index);
            Inc(Rlong,3);
          end;
      L := w;
    end;
  if Rlong<long then SeekPos(long-Rlong,SADD); (* en cas d'erreur ! *)
  if index<960 then
    for Jindex := index to 959 do M.Show[index] := vierge; (* erreur ! *)
end;
var NbreImg : byte;
    TypeOrg : byte;
    long    : word;
begin
  NbreImg := GetByte; (* nbre d'image *)
  while (NbreImg>0) and not(DriveAbandon) do
    begin
      TypeOrg := GetByte; (* type d'organisation image *)
      long := GetWord; (* longueur *)
      case TypeOrg of
        0 : begin (* type FULL *)
              LoadFullSingleImage;
            end;
        1 : begin (* type COMPILE 0 *)
              LoadCompil0SingleImage(long);
            end;
        2 : begin (* type COMPACT *)
              LoadCompact(long);
            end;
      else SeekPos(long,SADD);
      end;
      Dec(NbreImg);
    end;
end;

procedure LoadBlock(var point; size,long : word);
var index    : word;
    limite   : word;
    VarBlock : array[1..32767] of byte absolute point;
begin
  if long<size then limite := long
  else limite := size;
  for index := 1 to limite do VarBlock[index] := GetByte;
  if long>size then SeekPos(long-size,SADD);
end;

function GestLoad( var M : MemPg_Rec ) : boolean;
var version : byte;
    IDblock : byte;
    long    : word;
begin
  if LoadEnTete then
    begin (* bonne en tete *)
      InitParametrage(M);
      version := GetByte;
      long    := GetWord;
      (* pour n'importe quel version, on saute le block *)
      SeekPos(long,SADD);
      while (not(eof(fichier))) and not(DriveAbandon) do
        begin
          IDblock := GetByte;
          long    := GetWord;
          case IDblock of
            BIMAGE : LoadBIMAGE(M);
            BPANEL : SeekPos(long,SADD);
                     (* se comporte normalement s'il n'y a qu'une mmoire *)
                     (* sinon, on ignore le block BPANEL *)
            BPARAMETRES : LoadBlock(M.param,SizeOf(M.param),long);
            BCHAINAGE   : LoadBlock(M.Chain,SizeOf(M.Chain),long);
            BCODE1      : LoadBlock(M.Code1,SizeOf(M.Code1),long);
            BCODE2      : LoadBlock(M.Code2,SizeOf(M.Code2),long);
          else SeekPos(long,SADD); (* on saute car block inconnu *)
          end;
        end;
      GestLoad := true;
    end
  else
    GestLoad:=GestFileError(191);
end;

function LoadSingleMem( var M : MemPg_Rec; name:string) : boolean;
var io : word;
begin
  DriveAbandon := false;
  if name<>'' then
    begin
      assign(fichier,name);
      reset(fichier);
      io := ioresult;
      if GestFileError(io) then
        begin
          if GestLoad(M) then LoadSingleMem := CloseFile
          else
            begin
              LoadSingleMem := CloseFile; (* bidon *)
              LoadSingleMem := false;
            end;
        end
      else
        LoadSingleMem := false
    end
  else
    LoadSingleMem := GestFileError(190)
end;

(*************************)

end.
